using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Text;

namespace FontDialog
{
    /// <summary>
    /// Documentation can be found here: http://msdn.microsoft.com/en-us/library/dd145037(v=VS.85).aspx
    /// </summary>
    [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
    public struct LogFontStruct
    {
        public Int32 lfHeight;
        public Int32 lfWidth;
        public Int32 lfEscapement;
        public Int32 lfOrientation;
        public Int32 lfWeight;
        public Byte lfItalic;
        public Byte lfUnderline;
        public Byte lfStrikeOut;
        public Byte lfCharSet;
        public Byte lfOutPrecision;
        public Byte lfClipPrecision;
        public Byte lfQuality;
        public Byte lfPitchAndFamily;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 32)]
        public string lfFaceName;

        public LogFontStruct(byte[] rawData)
        {
            MemoryStream stream = new MemoryStream(rawData);
            BinaryReader br = new BinaryReader(stream, Encoding.Unicode);
            lfHeight = br.ReadInt32();
            lfWidth = br.ReadInt32();
            lfEscapement = br.ReadInt32();
            lfOrientation = br.ReadInt32();
            lfWeight = br.ReadInt32();
            lfItalic = br.ReadByte();
            lfUnderline = br.ReadByte();
            lfStrikeOut = br.ReadByte();
            lfCharSet = br.ReadByte();
            lfOutPrecision = br.ReadByte();
            lfClipPrecision = br.ReadByte();
            lfQuality = br.ReadByte();
            lfPitchAndFamily = br.ReadByte();
            lfFaceName = new string(br.ReadChars(32)).Trim('\0');
        }
    }
}